from apps.herd.services.services import rancher_quota_weight, get_rancher_statistics
from apps.warehouse.models import InventoryEntry, InventoryQuotaSaleTransaction
from apps.product.models import QuotaDistribution
from apps.core.models import SystemConfig
from django.db.models import Sum


def get_total_sold(rancher, inventory_entry: InventoryEntry = None, distribution: QuotaDistribution = None):
    """
    """
    if inventory_entry:
        return (
                InventoryQuotaSaleTransaction.objects.filter(
                    inventory_entry=inventory_entry,
                    rancher=rancher
                ).aggregate(total=Sum('weight'))['total'] or 0
        )

    elif distribution:
        return (
                InventoryQuotaSaleTransaction.objects.filter(
                    inventory_entry=inventory_entry,
                    rancher=rancher
                ).aggregate(total=Sum('weight'))['total'] or 0
        )


def can_buy_from_inventory(rancher, inventory_entry: InventoryEntry = None, distribution: QuotaDistribution = None):
    """
    """
    if SystemConfig.get("IGNORE_ALL_RANCHER_PURCHASE_LIMITS") == "true":
        return True

    if rancher.ignore_purchase_limit:
        return True

    if inventory_entry:
        # check if quota is open and acceptable to sale
        if inventory_entry.distribution.quota.is_in_valid_time():
            quota_weight = rancher_quota_weight(rancher, inventory_entry=inventory_entry)  # {total, by_type}
        else:
            return False

    elif distribution:
        # check if quota is open and acceptable to sale
        if distribution.quota.is_in_valid_time():
            quota_weight = rancher_quota_weight(rancher, distribution=distribution)  # {total, by_type}
        else:
            return False

    total_allowed = quota_weight['total']  # noqa

    total_sold = get_total_sold(inventory_entry, rancher)

    return total_sold < total_allowed
